#   The level generation functions and various related functions

#   Jellyfish Quest
#   Copyright (C) 2009 Ben Whittaker

import pygame
from pygame.locals import *
import math

from base import *
from objects import *

##def baywaves(frames, level, para):
##    pointlist = []
##    for x in range(int(((env.boundries[0] - screensize[0]) * para + screensize[0]) / 2 + 1)):
##        x *= 2
##        y = (math.sin((x * para + frames / 2) * math.pi / 32) + math.sin((x * para - frames / 4) * math.pi / 16) / 2) * para + env.waterlevel
##        pointlist += [[x, y]]
##    return pointlist

def rightedgewin():
    if PlayerGroup.sprite <> None:
        if PlayerGroup.sprite.pos[0] >= env.boundries[0] - 1:
            return True
    return False

baywavecache = {}
def baywaves(x, frames):
    x = int(x)
    #frames = int(frames)
    ident = (x % 64, frames % 128)
    if ident not in baywavecache:
        baywavecache[ident] =  math.sin((x + frames / 2) * math.pi / 32) + math.sin((x - frames / 4) * math.pi / 16) / 2
        #print len(baywavecache)
    return baywavecache[ident]

def testlevel():
    mainlayer = ParaLayer(mask = "Mock_Jellyfish_Level-mask.png", pos = [-8, -8])
    layers = [
        ParaLayer(parallax = 0.001, image = "Beach_Back0.png", water = True),
        ParaLayer(parallax = 2**-3.5, water = True),
        ParaLayer(parallax = 0.125, image = "Beach_Back1.png"),# water = True),
        ParaLayer(parallax = 2**-2.5, water = True),
        ParaLayer(parallax = 2**-1.5, water = True),
        ParaLayer(parallax = 2**-0.5, water = True),
        ParaLayer(image = "Mock_Jellyfish_Level-ground.png", water = True),
        mainlayer,
        ParaLayer(image = "Mock_Jellyfish_Level-foreground.png", water = True)
        ]
    p = Player([12, 12], get_keyset(), mainlayer)
    #distribute(10, Rock, mainlayer, (0, 0), (288, 96))
    #distribute(2, SwordFish, mainlayer, (0, 0), (288, 96))
    for a in range(2):
        Jellyfish([45, 45], mainlayer)
        Jellyfish([100, 30], mainlayer)
    distribute(5, Mine, mainlayer, (0, 25), (135, 50))
    Crab([270, 30], mainlayer)
    Crab([165, 0], mainlayer)
    MadUrch([70, 40], mainlayer)
    Frog([160, 10], mainlayer)
    for a in range(30):
        Fish([random.randrange(0, 140), random.randrange(30, 60)], mainlayer)
    #for a in range(2):
    #    SaberFish([random.randrange(0, 140), random.randrange(30, 60)], mainlayer)
    b1 = Button([122, 59], mainlayer)
    Gate([144, 52], mainlayer, size = 24, trigger = b1)
    env.init(layers, 18, (0, 0, 150, 50), baywaves, (288, 96))
    playmusic("Mozart_Piano_Sonata_Amin3.ogg")

def level1_1():
    mainlayer = ParaLayer(mask = "1-1mask.png", pos = [-8, -8])
    layers = [
        ParaLayer(parallax = 0.001, image = "Beach_Back0.png", water = True),
        #ParaLayer(parallax = 2**-6.5, water = True),
        #ParaLayer(parallax = 2**-5.5, water = True),
        #ParaLayer(parallax = 2**-4.5, water = True),
        ParaLayer(parallax = 0.0625, image = "Beach_Back1.png"),
        ParaLayer(parallax = 2**-3.5, water = True),
        ParaLayer(parallax = 2**-2.5, water = True),
        ParaLayer(parallax = 2**-1.5, water = True),
        ParaLayer(parallax = 2**-0.5, water = True),
        ParaLayer(image = "1-1ground.png", water = True),
        mainlayer,
        ParaLayer(image = "1-1foreground.png", water = True)
        ]
    Static([53, 23], "1-1waterfall-a.png", [28, 27], layers[-3], 5)
    LillyPad([137, 40], (140, 45), layers[-3])
    Static([41, 21], "1-1waterfall-b.png", [26, 27], layers[-1], 5)
    LillyPad([157, 40], (160, 45), layers[-1])
    LillyPad([174, 40], (178, 48), layers[-1])
    Rock([250, 100], mainlayer, size = 1)
    Rock([238, 100], mainlayer, size = 0)
    Rock([395, 88], mainlayer, size = 0)
    Rock([393, 84], mainlayer, size = 1)
    Rock([393, 89], mainlayer, size = 2)
    Rock([82, 80], mainlayer, size = 0)
    distribute(75, Fish, mainlayer, (0, 45), (544, 160))
    distribute(5, Jellyfish, mainlayer, (0, 45), (544, 160))
    distribute(3, SaberFish, mainlayer, (100, 45), (544, 160))
    Crab([300, 125], mainlayer)
    Crab([500, 100], mainlayer)
    Frog([205, 75], mainlayer)
    MadUrch([183, 100], mainlayer)
    Bonus([28, 121], mainlayer)
    Bonus([233, 92], mainlayer)
    Bonus([447, 60], mainlayer)
    Clam([338, 127], mainlayer, childtype = "bonus")
    Clam([485, 102], mainlayer)
    Clam([140, 121], mainlayer)
    Player([70, 50], get_keyset(), mainlayer)
    env.init(layers, 44, (0, 0, 150, 50), baywaves, (544, 160), rightedgewin)
    playmusic("04 - island (daytime).ogg")

def level1_2():
    mainlayer = ParaLayer(mask = "1-2mask.png", pos = [-8, -8])
    layers = [
        ParaLayer(parallax = 0.001, image = "Beach_Back0.png", water = True),
        #ParaLayer(parallax = 0.0625, image = "Beach_Back1.png"),
        ParaLayer(parallax = 2**-3.5, water = True),
        ParaLayer(parallax = 2**-2.5, water = True),
        ParaLayer(parallax = 2**-1.5, water = True),
        ParaLayer(parallax = 2**-0.5, water = True),
        ParaLayer(image = "1-2ground.png", water = True),
        mainlayer,
        ParaLayer(image = "1-2foreground.png", water = True)
        ]
    LillyPad([259, 40], (262, 45), layers[-3])
    LillyPad([230, 40], (233, 45), layers[-1])
    LillyPad([281, 40], (284, 48), layers[-1])
    Rock([31, 100], mainlayer, size = 2)
    Rock([16, 95], mainlayer, size = 1)
    Rock([87, 55], mainlayer, size = 3)
    Rock([104, 55], mainlayer, size = 1)
    Rock([96, 55], mainlayer, size = 2)
    Rock([93, 50], mainlayer, size = 1)
    Rock([99, 50], mainlayer, size = 0)
    Rock([114, 54], mainlayer, size = 0)
    Rock([125, 80], mainlayer, size = 1)
    Rock([250, 124], mainlayer, size = 1)
    distribute(50, Fish, mainlayer, (0, 45), (416, 224))
    distribute(10, SaberFish, mainlayer, (0, 45), (416, 224))
    MadUrch([100, 164], mainlayer)
    MadUrch([100, 81], mainlayer)
    Crab([138, 142], mainlayer)
    Crab([335, 190], mainlayer)
    Clam([116, 135], mainlayer)
    Clam([365, 102], mainlayer)
    Frog([70, 35], mainlayer)
    Bonus([91, 161], mainlayer)
    Bonus([119, 55], mainlayer)
    Bonus([265, 123], mainlayer)
    Bonus([401, 193], mainlayer)
    b1 = Button([186, 81], mainlayer)
    Gate([204, 38], mainlayer, size = 32, trigger = b1, ori = [0, -1])
    b2 = Button([279, 126], mainlayer, colour = 3)
    Gate([296, 110], mainlayer, colour = 3, size = 15, trigger = b2)
    Gate([149, 109], mainlayer, colour = 3, size = 9, trigger = b2, ori = [1, 0])
    Player([3, 67], get_keyset(), mainlayer)
    env.init(layers, 44, (0, 0, 150, 50), baywaves, (416, 224), rightedgewin)
    playmusic("04 - island (daytime).ogg")

def level1_3():
    mainlayer = ParaLayer(mask = "1-3mask.png", pos = [-8, -8])
    layers = [
        ParaLayer(parallax = 0.001, image = "Beach_Back0.png", water = True),
        #ParaLayer(parallax = 0.0625, image = "Beach_Back1.png"),
        ParaLayer(parallax = 2**-3.5, water = True),
        ParaLayer(parallax = 2**-2.5, water = True),
        ParaLayer(parallax = 2**-1.5, water = True),
        ParaLayer(parallax = 2**-0.5, water = True),
        ParaLayer(image = "1-3ground.png", water = True),
        mainlayer,
        ParaLayer(image = "1-3foreground.png", water = True)
        ]
    Rock([87, 67], mainlayer, size = 2)
    Rock([95, 67], mainlayer, size = 1)
    Rock([225, 65], mainlayer, size = 1)
    Rock([249, 65], mainlayer, size = 0)
    Rock([255, 65], mainlayer, size = 0)
    Rock([323, 157], mainlayer, size = 1)
    Rock([285, 137], mainlayer, size = 1)
    Rock([321, 99], mainlayer, size = 0)
    Inert([186, 75], 3, 100, "pickaxe.png", mainlayer, groups = [Grabbables, HardBodies])
    #Inert([372, -5], 0.125, 50, "1-2cage.png", mainlayer, groups = [HardBodies])
    LiftCage([371, 65], mainlayer)
    distribute(50, Fish, mainlayer, (0, 45), (416, 224))
    distribute(10, SaberFish, mainlayer, (0, 45), (416, 224))
    distribute(5, SwordFish, mainlayer, (0, 45), (416, 224))
    Clam([266, 190], mainlayer)
    Clam([347, 90], mainlayer)
    Clam([167, 75], mainlayer)
    MadUrch([84, 63], mainlayer)
    MadUrch([238, 60], mainlayer)
    MadUrch([253, 199], mainlayer)
    Crab([295, 200], mainlayer)
    Crab([175, 170], mainlayer)
    Frog([125, 60], mainlayer)
    Bonus([122, 119], mainlayer)
    Bonus([180, 77], mainlayer)
    Bonus([143, 168], mainlayer)
    Bonus([361, 198], mainlayer)
    Player([6, 60], get_keyset(), mainlayer)
    env.init(layers, 44, (0, 0, 150, 50), baywaves, (416, 224), rightedgewin)
    playmusic("04 - island (daytime).ogg")

def level1_4():
    mainlayer = ParaLayer(mask = "1-4mask.png", pos = [-8, -8])
    layers = [
        ParaLayer(parallax = 0.001, image = "Beach_Back0.png", water = True),
        #ParaLayer(parallax = 0.0625, image = "Beach_Back1.png"),
        ParaLayer(parallax = 2**-3.5, water = True),
        ParaLayer(parallax = 2**-2.5, water = True),
        ParaLayer(parallax = 2**-1.5, water = True),
        ParaLayer(parallax = 2**-0.5, water = True),
        ParaLayer(image = "1-4ground.png", water = True),
        mainlayer,
        ParaLayer(image = "1-4foreground.png", water = True)
        ]
    Rock([36, 81], mainlayer, size = 0)
    Rock([45, 70], mainlayer, size = 0)
    Rock([43, 74], mainlayer, size = 1)
    Rock([43, 79], mainlayer, size = 3)
    Rock([51, 80], mainlayer, size = 1)
    Rock([57, 79], mainlayer, size = 0)
    Rock([61, 77], mainlayer, size = 1)
    Rock([73, 80], mainlayer, size = 1)
    Rock([77, 83], mainlayer, size = 1)
    Rock([243, 60], mainlayer, size = 2)
    Rock([250, 59], mainlayer, size = 0)
    Rock([251, 62], mainlayer, size = 1)
    Rock([83, 82], mainlayer, size = 2)
    Rock([277, 218], mainlayer, size = 2)
    Rock([89, 79], mainlayer, size = 1)
    Rock([95, 78], mainlayer, size = 0)
    distribute(20, Fish, mainlayer, (0, 110), (352, 288))
    distribute(10, Fish, mainlayer, (40, 21), (352, 110))
    distribute(10, Jellyfish, mainlayer, (160, 21), (352, 70))
    distribute(10, SaberFish, mainlayer, (40, 21), (352, 288))
    distribute(10, SwordFish, mainlayer, (40, 21), (352, 288))
    Clam([112, 222], mainlayer)
    Clam([210, 244], mainlayer)
    MadUrch([40, 267], mainlayer)
    MadUrch([306, 222], mainlayer)
    MadUrch([278, 39], mainlayer)
    Crab([165, 265], mainlayer)
    Crab([185, 125], mainlayer)
    Crab([315, 45], mainlayer)
    Frog([345, 45], mainlayer)
    Clam([53, 75], mainlayer, childtype = "bonus")
    Bonus([241, 63], mainlayer)
    Bonus([313, 164], mainlayer)
    Bonus([346, 82], mainlayer)
    b1 = Button([240, 233], mainlayer)
    Gate([210, 105], mainlayer, size = 18, trigger = b1)
    b2 = Button([304, 227], mainlayer, colour = 3)
    Gate([350, 78], mainlayer, colour = 3, size = 18, trigger = b2)
    Gate([350, 97], mainlayer, colour = 3, size = 18, trigger = b2, ori = [0, -1])
    WaterLevelChanger(110, 21, b2)
    Player([8, 234], get_keyset(), mainlayer)
    env.init(layers, 110, (0, 0, 150, 50), baywaves, (352, 288), rightedgewin)
    # water rises from 110 to 21
    playmusic("04 - island (daytime).ogg")

levellist = [
    ("Lvl 1-1/Jellyfish/Bay", level1_1),
    ("Lvl 1-2/Buttons/'n Stuff", level1_2),
    ("Lvl 1-3/Mind the/Coral", level1_3),
    ("Lvl 1-4/Tiding/You Over", level1_4),
    ("Lvl Tst/That's/All,Folks", testlevel)
    ]
